give @p minecraft:written_book[minecraft:written_book_content={\
	author:"Aghast365",\
	title:"Hologram Generator",\
	pages:[\
		'[\
			"Hologram Generator\\n\\n",\
			"Create holograms of any in-game area!\\n\\n",\
			{"text":"Note: ","color":"gray"},\
			{"text":"increase the command chain length","underlined":true,"bold":true,"color":"gray",\
				"clickEvent":{"action":"run_command","value":"/gamerule maxCommandChainLength 1000000"},\
				"hoverEvent":{"action":"show_text","value":"/gamerule maxCommandChainLength 1000000"}},\
			{"text":" when working with large areas\\n\\n", "color":"gray"},\
			{"text":"Create Holograms\\n","underlined":true,"bold":true, "color":"dark_green",\
				"clickEvent":{"action":"change_page","value":"2"},\
				"hoverEvent":{"action":"show_text","value":"Create: Page 2"}},\
			{"text":"Remove Holograms\\n", "underlined":true,"bold":true, "color":"red",\
				"clickEvent":{"action":"change_page","value":"3"},\
				"hoverEvent":{"action":"show_text","value":"Remove: Page 3"}},\
			{"text":"Settings","underlined":true,"bold":true,"color":"gold",\
				"clickEvent":{"action":"change_page","value":"4"},\
				"hoverEvent":{"action":"show_text","value":"Settings: Page 4"}}\
		]',\
		'[\
			{"text":"Define Origin and Destination\\n\\n","color":"green","underlined":true,"bold":true,\
				"clickEvent":{"action":"run_command","value":"/function hologram:generator/get_markers"},\
				"hoverEvent":{"action":"show_text","value":"Place at opposing corners of the area and at the destination.\\nMultiple areas/destinations may be set."}},\
			{"text":"Start the Generator\\n\\n","color":"green","underlined":true,"bold":true,\
				"clickEvent":{"action":"run_command","value":"/function hologram:generator/start"},\
				"hoverEvent":{"action":"show_text","value":"Create the hologram! Should only take a few seconds"}},\
			{"text":"Clear Origin and Destination Markers\\n\\n\\n\\n","color":"red","underlined":true,"bold":true,\
				"clickEvent":{"action":"run_command","value":"/function hologram:generator/clear_markers"},\
				"hoverEvent":{"action":"show_text","value":"Clears markers in all (loaded) areas"}},\
			{"text":"Emergency Stop","color":"dark_red","underlined":true,"bold":true,\
				"clickEvent":{"action":"run_command","value":"/function hologram:generator/stop"},\
				"hoverEvent":{"action":"show_text","value":"Use in case of extreme lag when generating.\\nWarning: May damage existing holograms."}}\
		]',\
		'[\
			{"text":"Clear Holograms in Current Block\\n\\n","color":"gold","underlined":true,"bold":true,\
				"clickEvent":{"action":"run_command","value":"/kill @e[tag=hologram_block,distance=...5]"},\
				"hoverEvent":{"action":"show_text","value":"/kill @e[tag=hologram_block,distance=...5]"}},\
			{"text":"Clear Holograms Within 5 Blocks\\n\\n","color":"gold","underlined":true,"bold":true,\
				"clickEvent":{"action":"run_command","value":"/kill @e[tag=hologram_block,distance=..10]"},\
				"hoverEvent":{"action":"show_text","value":"/kill @e[tag=hologram_block,distance=..10]"}},\
			{"text":"Clear Holograms Within 20 Blocks\\n\\n\\n\\n\\n","color":"red","underlined":true,"bold":true,\
				"clickEvent":{"action":"run_command","value":"/kill @e[tag=hologram_block,distance=..20]"},\
				"hoverEvent":{"action":"show_text","value":"/kill @e[tag=hologram_block,distance=..20]"}},\
			{"text":"Clear Everything","color":"dark_red","underlined":true,"bold":true,\
				"clickEvent":{"action":"copy_to_clipboard","value":"/kill @e[tag=hologram]"},\
				"hoverEvent":{"action":"show_text","value":"/kill @e[tag=hologram]\\nKills all holograms and any related entities.\\nClick to copy to clipboard, then paste into chat to confirm."}}\
		]',\
		'[\
			{"text":""},\
			{"text":"Render Fluids: \\n","color":"blue", \
				"hoverEvent":{"action":"show_text","value":"Represent water and lava in holograms, using blocks as a stand-in\\nDefault: Disabled"}}, \
			{"text":"Enable","color":"green","underlined":true,"bold":true, \
				"clickEvent":{"action":"run_command","value":"/data modify storage hologram:config fluid_display.enabled set value 1"},\
				"hoverEvent":{"action":"show_text","value":"Enable"}},\
			" - ", \
			{"text":"Disable\\n","color":"red","underlined":true,"bold":true, \
				"clickEvent":{"action":"run_command","value":"/data modify storage hologram:config fluid_display.enabled set value 0"},\
				"hoverEvent":{"action":"show_text","value":"Disable"}},\
			{"text":"Set Fluid Blocks\\n\\n","color":"gold","underlined":true,"bold":true, \
				"clickEvent":{"action":"copy_to_clipboard","value":"/data modify storage hologram:config fluid_display.blocks set value {water:\\"light_blue_stained_glass\\",lava:\\"orange_stained_glass\\"}"},\
				"hoverEvent":{"action":"show_text","value":"Change the blocks used to represent each fluid.\\nClick to copy, paste into chat to edit"}},\
			{"text":"Collisions: \\n","color":"blue", \
				"hoverEvent":{"action":"show_text","value":"Use invisible shulkers to add collisions to the hologram\\nDefault: Disabled"}},\
			{"text":"Enable","color":"green","underlined":true,"bold":true,\
				"clickEvent":{"action":"run_command","value":"/data modify storage hologram:config collisions.enabled set value 1"},\
				"hoverEvent":{"action":"show_text","value":"Enable"}},\
			" - ",\
			{"text":"Disable\\n","color":"red","underlined":true,"bold":true,\
				"clickEvent":{"action":"run_command","value":"/data modify storage hologram:config collisions.enabled set value 0"},\
				"hoverEvent":{"action":"show_text","value":"Disable"}},\
			{"text":"Collision Detection:\\n","color":"blue",\
				"hoverEvent":{"action":"show_text","value":"If collisions are enabled, only add collisions to solid/partial blocks\\nDefault: Enabled"}},\
			{"text":"Enable","color":"green","underlined":true,"bold":true,\
				"clickEvent":{"action":"run_command","value":"/data modify storage hologram:config collisions.strict set value 1"},\
				"hoverEvent":{"action":"show_text","value":"Enable"}},\
			" - ",\
			{"text":"Disable\\n\\n","color":"red","underlined":true,"bold":true,\
				"clickEvent":{"action":"run_command","value":"/data modify storage hologram:config collisions.strict set value 0"},\
				"hoverEvent":{"action":"show_text","value":"Disable"}},\
			{"text":"Keep Markers:\\n","color":"blue",\
				"hoverEvent":{"action":"show_text","value":"Whether to remove the current area/destination markers after generation\\nDefault: Keep Origin, Remove Destination"}},\
			{"text":"Origin: ","color":"gold"},\
			{"text":"Yes","color":"green","bold":true,"underlined":true,\
				"clickEvent":{"action":"run_command","value":"/data modify storage hologram:config keep_markers.origin set value 1"},\
				"hoverEvent":{"action":"show_text","value":"Keep Origin"}},\
			" - ",\
			{"text":"No\\n","color":"red","bold":true,"underlined":true,\
				"clickEvent":{"action":"run_command","value":"/data modify storage hologram:config keep_markers.origin set value 0"},\
				"hoverEvent":{"action":"show_text","value":"Remove Origin"}},\
			{"text":"Destination: ","color":"gold"},\
			{"text":"Yes","color":"green","bold":true,"underlined":true,\
				"clickEvent":{"action":"run_command","value":"/data modify storage hologram:config keep_markers.destination set value 1"},\
				"hoverEvent":{"action":"show_text","value":"Keep Destination"}},\
			" - ",\
			{"text":"No\\n\\n","color":"red","bold":true,"underlined":true,\
				"clickEvent":{"action":"run_command","value":"/data modify storage hologram:config keep_markers.destination set value 0"},\
				"hoverEvent":{"action":"show_text","value":"Remove Destination"}},\
			{"text":"Continued -->"}\
		]',\
		'[\
			{"text":""},\
			{"text":"Scale:\\n","color":"blue",\
				"hoverEvent":{"action":"show_text","value":"Change the scale of the rendered hologram.\\nDefault: 1/8"}},\
			{"text":"1/16","color":"green","bold":true,"underlined":true,\
				"clickEvent":{"action":"run_command","value":"/data modify storage hologram:config scale.scale set value 0.0625"},\
				"hoverEvent":{"action":"show_text","value":"0.0625x"}},\
			" - ",\
			{"text":"1/8","color":"green","bold":true,"underlined":true,\
				"clickEvent":{"action":"run_command","value":"/data modify storage hologram:config scale.scale set value 0.125"},\
				"hoverEvent":{"action":"show_text","value":"0.125x"}},\
			" - ",\
			{"text":"1/4","color":"green","bold":true,"underlined":true,\
				"clickEvent":{"action":"run_command","value":"/data modify storage hologram:config scale.scale set value 0.25"},\
				"hoverEvent":{"action":"show_text","value":"0.25x"}},\
			" - ",\
			{"text":"1/2","color":"green","bold":true,"underlined":true,\
				"clickEvent":{"action":"run_command","value":"/data modify storage hologram:config scale.scale set value 0.5"},\
				"hoverEvent":{"action":"show_text","value":"0.5x"}},\
			" - ",\
			{"text":"1","color":"green","bold":true,"underlined":true,\
				"clickEvent":{"action":"run_command","value":"/data modify storage hologram:config scale.scale set value 1"},\
				"hoverEvent":{"action":"show_text","value":"1x"}},\
			" - ",\
			{"text":"2","color":"green","bold":true,"underlined":true,\
				"clickEvent":{"action":"run_command","value":"/data modify storage hologram:config scale.scale set value 2"},\
				"hoverEvent":{"action":"show_text","value":"2x"}},\
			" - ",\
			{"text":"3\\n","color":"green","bold":true,"underlined":true,\
				"clickEvent":{"action":"run_command","value":"/data modify storage hologram:config scale.scale set value 3"},\
				"hoverEvent":{"action":"show_text","value":"3x"}},\
			{"text":"Set Custom Scale\\n","color":"gold","underlined":true,"bold":true, \
				"clickEvent":{"action":"copy_to_clipboard","value":"/data modify storage hologram:config scale.scale set value .125"},\
				"hoverEvent":{"action":"show_text","value":"Set a custom scale. Click to copy, paste into chat to edit\\nNote: Disable collisions when using scales outside the range 1/16x-3x"}},\
			{"text":"Get Scaling Boots\\n\\n","color":"dark_green","underlined":true,"bold":true, \
				"clickEvent":{"action":"run_command","value":"/function hologram:get_boots"},\
				"hoverEvent":{"action":"show_text","value":"Get boots that set your size to the current scale\\nWorks between 1/16x-16x"}},\
			{"text":"Precision:\\n","color":"blue",\
				"hoverEvent":{"action":"show_text","value":"Used for calculations internally.\\nOnly change when using a custom scale less than .0001 or greater than 1000\\nDefault: Med"}},\
			{"text":"High","color":"green","bold":true,"underlined":true,\
				"clickEvent":{"action":"run_command","value":"/data merge storage hologram:config {scale:{precision:1000000,inverse_precision:.000001}}"},\
				"hoverEvent":{"action":"show_text","value":"For scales less than .0001"}},\
			" - ",\
			{"text":"Med","color":"green","bold":true,"underlined":true,\
				"clickEvent":{"action":"run_command","value":"/data merge storage hologram:config {scale:{precision:10000,inverse_precision:.0001}}"},\
				"hoverEvent":{"action":"show_text","value":"For scales between .0001 and 1000"}},\
			" - ",\
			{"text":"Low\\n\\n\\n","color":"green","bold":true,"underlined":true,\
				"clickEvent":{"action":"run_command","value":"/data merge storage hologram:config {scale:{precision:1,inverse_precision:1}}"},\
				"hoverEvent":{"action":"show_text","value":"For scales greater than 1000"}},\
			{"text":"Reset all to Defaults","color":"dark_red","underlined":true,"bold":true,\
				"clickEvent":{"action":"copy_to_clipboard","value":"/function hologram:config/load_defaults"},\
				"hoverEvent":{"action":"show_text","value":"Reset all settings.\\nClick to copy to clipboard, then paste into chat to confirm."}}\
		]'\
	]\
}]